=== debian/changelog ===
nanomsg (1.1.5+dfsg-1) unstable; urgency=medium

  * New watch file.
  * Update d/copyright
  * Drop patches applied upstream.
  * New upstream version 1.1.5+dfsg (Closes: #858172)
  * Bump symbols
  * Cleanup after nanomsg-utils changes.
  * Switch to salsa
  * Cleanup from major upstream changes.
  * Add missing Expat License directive.
  * Fix rpath issue with patch.
  * Dump the docs in the main docs.
  * Remove Google webfonts that are a privacy violation.
  * Make sure package is fully hardened. (Closes: #822520)
  * Add doc-base.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 21 Oct 2018 20:17:21 -0400
