=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg(\.?\d+)?$//,repacksuffix=+dfsg" \
https://github.com/nanomsg/nanomsg/tags .*/v?(\d\S+)\.tar\.gz
