## nanomsg 1.2.1+dfsg

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -384,6 +384,9 @@
 set(PACKAGE_INSTALL_DESTINATION
     ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${NN_PACKAGE_VERSION}
 )
+set(PACKAGE_INSTALL_FULL_DESTINATION
+    ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/${PROJECT_NAME}-${NN_PACKAGE_VERSION}
+)
 install(EXPORT ${PROJECT_NAME}-target
     DESTINATION ${PACKAGE_INSTALL_DESTINATION}
 )
@@ -393,7 +396,7 @@
     COMPATIBILITY SameMajorVersion
 )
 configure_package_config_file(
-    ${CMAKE_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
+    ${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
     ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
     INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
     PATH_VARS CMAKE_INSTALL_PREFIX
