=== debian/changelog ===
nanomsg (1.2.1+dfsg-1) experimental; urgency=medium

  * New upstream version 1.2.1.
  * Remove not required patches.
  * Remove not required lintian overrides.
  * 'd/libnanomsg6.symbols': Correct typographical error.

 -- Phil Wyett <philip.wyett@kathenas.org>  Wed, 21 Feb 2024 06:58:27 +0000

nanomsg (1.2+dfsg-1) experimental; urgency=medium

  * New upstream version 1.2.
  * Soname bump rename package to libnanomsg6.
  * New maintainer (Closes: #871443).
  * d/control: Use debhelper-compat 13.
    - Update paths for missing files.
  * d/control: Use HTTPS homepage URL.
  * d/control: Remove unneeded '${shlibs:Depends}'.
  * d/control: Update 'Standards-Version' to 4.6.2.0 - No Changes required.
  * d/control: Add 'Rules-Requires-Root: no'.
  * d/copyright: Remove 'License: Expat' from header section.
  * Add 'd/patches/lintian-overrides'.
    - Add 'nanomsg source: debian-watch-does-not-check-openpgp-signature'.
    - Add 'nanomsg source: very-long-line-length-in-source-file'
  * Add 'd/upstream/metadata'.
  * d/watch: Use latest GitHub API format.
  * d/README.source: Remove old data about archive naming.
  * Add patch: 0003-change-version.patch
    - Change version in '.version' from 1.1.5 to 1.2.0.
  * Fix 'doc-base' now locating files in 'libnanomsg-dev' binary package.
  * Add 'Build-Depends-Package' field to symbols file. Eliminates lintian
    warning 'symbols-file-missing-build-depends-package-field'.
  * Make linanomsg6 and libnanomsg-dev both Multi-Arch: same.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sun, 10 Dec 2023 18:55:14 +0000

nanomsg (1.1.5+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply a patch by Vagrant Cascadian to address Build-Id differences in
    binaries caused by a difference in RPATH. (Closes: #1001853)

 -- Chris Lamb <lamby@debian.org>  Tue, 10 Jan 2023 16:33:43 +0000
