=== debian/control ===
--- 
+++ 
@@ -1,19 +1,47 @@
 Source: nanomsg
 Priority: optional
 Section: libs
-Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
-Build-Depends: debhelper (>= 11~),
+Maintainer: Phil Wyett <philip.wyett@kathenas.org>
+Build-Depends: debhelper-compat (= 13),
                asciidoctor,
-	       cmake
-Standards-Version: 4.2.1
-Homepage: http://nanomsg.org/
+	           cmake
+Standards-Version: 4.6.2.0
+Rules-Requires-Root: no
+Homepage: https://nanomsg.org/
 Vcs-Git: https://salsa.debian.org/debian/nanomsg.git
 Vcs-Browser: https://salsa.debian.org/debian/nanomsg
+
+Package: libnanomsg6
+Architecture: any
+Multi-Arch: same
+Breaks: libnanomsg5
+Replaces: libnanomsg5
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: high-performance implementation of scalability libraries
+ nanomsg is a socket library that provides several common
+ communication patterns. It aims to make the networking layer fast,
+ scalable, and easy to use. Implemented in C, it works on a wide range
+ of operating systems with no further dependencies.
+ .
+ The communication patterns, also called "scalability protocols", are
+ basic blocks for building distributed systems. By combining them you
+ can create a vast array of distributed applications. The following
+ scalability protocols are currently available:
+ .
+    PAIR - simple one-to-one communication
+    BUS - simple many-to-many communication
+    REQREP - allows one to build clusters of stateless services
+             to process user requests
+    PUBSUB - distributes messages to large sets of interested subscribers
+    PIPELINE - aggregates messages from multiple sources and
+               load balances them among many destinations
+    SURVEY - allows one to query state of multiple applications in a single go
 
 Package: libnanomsg-dev
 Section: libdevel
 Architecture: any
-Depends: libnanomsg5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Depends: libnanomsg6 (= ${binary:Version}), ${misc:Depends}
 Description: nanomsg development files
  nanomsg is a socket library that provides several common
  communication patterns. It aims to make the networking layer fast,
@@ -38,7 +66,7 @@
 
 Package: nanomsg-utils
 Architecture: any
-Depends: libnanomsg5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libnanomsg6 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: nanomsg utilities
  nanomsg is a socket library that provides several common
  communication patterns. It aims to make the networking layer fast,
@@ -60,26 +88,3 @@
     SURVEY - allows one to query state of multiple applications in a single go
  .
  This package contains utilities for testing nanomsg.
-
-Package: libnanomsg5
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: high-performance implementation of scalability libraries
- nanomsg is a socket library that provides several common
- communication patterns. It aims to make the networking layer fast,
- scalable, and easy to use. Implemented in C, it works on a wide range
- of operating systems with no further dependencies.
- .
- The communication patterns, also called "scalability protocols", are
- basic blocks for building distributed systems. By combining them you
- can create a vast array of distributed applications. The following
- scalability protocols are currently available:
- .
-    PAIR - simple one-to-one communication
-    BUS - simple many-to-many communication
-    REQREP - allows one to build clusters of stateless services
-             to process user requests
-    PUBSUB - distributes messages to large sets of interested subscribers
-    PIPELINE - aggregates messages from multiple sources and
-               load balances them among many destinations
-    SURVEY - allows one to query state of multiple applications in a single go
