=== debian/watch ===
version=4
opts="searchmode=plain,dversionmangle=s/\+dfsg(\.?\d+)?$//,repacksuffix=+dfsg, \
filenamemangle=s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/nanomsg/nanomsg/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
